<?php

require_once "config_parsers.php";

class favorite_folder extends config
{
  const dir_main_screen_items = '/config/main_screen_items';
  const settings_properties   = '/config/settings.properties';

  private $_path_to_favorite_folder = '';
  private $_favorite_folders = array ();

  public function get_property ($index = 1)
  {
    if (!self::_opened == $this->_status)
      return false;

    return $this->_ini_string;
  }

  public function get_properties ()
  {
    if (!$this->_favorite_folders)
      return false;

    $properties = array ();
    foreach ($this->_favorite_folders as $dir_name)
    {
      if (!strcmp ($dir_name, ".") || !strcmp ($dir_name, ".."))
        continue;

      if ($this->open(self::dir_main_screen_items . '/' . $dir_name . '/dune_folder.txt'))
      {
        if (!self::_opened == $this->_status)
          break;

        $properties[$dir_name] = $this->get_property (0);
      }
    }

    return $properties;
  }

  public function open_folder($path_to_favorite_folder)
  {
    $this->_favorite_folders = scandir($path_to_favorite_folder);
    if ($this->_favorite_folders)
    {
      $this->_path_to_favorite_folder = $path_to_favorite_folder;
    }
    return $this->_favorite_folders;
  }

  public function remove_item ($favorite_name)
  {
    $select_dir = self::dir_main_screen_items . '/' . $favorite_name;
    if (is_dir ($select_dir))
    {
      if (unlink ($select_dir . '/dune_folder.txt'))
      {
        return rmdir ($select_dir);
      }
    }

    return false;
  }

  public function add_item ($favorite_name, $favorite_media_url)
  {
    if (!strlen ($favorite_name) && !strlen ($favorite_media_url))
      return false;

    $favorite_dir = self::dir_main_screen_items . '/' . $favorite_name;
    //$favorite_name = '...'
    $favorite_media_url_check = 'no';
    $favorite_media_action = 'browse';

    $dune_folder_content = <<<TXT
media_url = {$favorite_media_url}
media_url_check = {$favorite_media_url_check}
TXT;

    $path_parts = pathinfo ($favorite_media_url);
    if (!strlen (safely_get_value_of_global_variables ($path_parts, 'extension')))
    {
      $dune_folder_content .= "\nmedia_action = {$favorite_media_action}";
    }

    $this->remove_item ($favorite_name);

    if (!is_dir ($favorite_dir))
    {
      if (mkdir ($favorite_dir, umask (), true))
      {
        $fp = fopen ($favorite_dir . '/dune_folder.txt', 'w');
        if ($fp)
        {
          fwrite ($fp, $dune_folder_content);
          fclose ($fp);
          return true;
        }
      }
    }

    return false;
  }

  public function close_folder()
  {
    $this->_path_to_favorite_folder = '';
    $this->_favorite_folders = array ();
    $this->close();
  }

  public function power_on_action ($favorite_name)
  {
    $settings_properties_ini = INI::read (self::settings_properties);

    $settings_properties_ini['default']['power_on_action'] = 'favorite:' . $favorite_name;
    INI::write (self::settings_properties, $settings_properties_ini);

    return true;
  }

  public function power_off_action ()
  {
    $settings_properties_ini = INI::read (self::settings_properties);

    $settings_properties_ini['default']['power_on_action'] = 'default';
    INI::write (self::settings_properties, $settings_properties_ini);

    return true;
  }

  public function get_power_on_action ()
  {
    $settings_properties_ini = INI::read (self::settings_properties);
    return $settings_properties_ini['default']['power_on_action'];
  }
}
