<?php

require_once "config_parsers.php";

class network_folder extends config
{
  public function get_property ($index = 1)
  {
    if (!self::_opened == $this->_status)
      return false;

    return array (
      'name'      => $this->_ini_string['name.'      . $index],
      'type'      => $this->_ini_string['type.'      . $index],
      'server'    => $this->_ini_string['server.'    . $index],
      'directory' => $this->_ini_string['directory.' . $index],
      'user'      => $this->_ini_string['user.'      . $index],
      'password'  => $this->_ini_string['password.'  . $index],
      'protocol'  => $this->_ini_string['protocol.'  . $index]
    );
  }

  public function get_properties ()
  {
    if (!self::_opened == $this->_status)
      return false;

    $properties = array ();
    for ($i = $this->get_index(), $j = 0; $i > 0; $i--, $j++)
    {
      $properties[] = $this->get_property ($j);
    }

    return $properties;
  }

  public function delete_network_folder ($network_folder_name)
  {
    if (!self::_opened == $this->_status)
      return false;

    $network_folder_ini = INI::read ($this->_path_to_network_folder_config);

    foreach ($network_folder_ini['default']['name'] as $key => $value)
    {
      if (!strcasecmp ($network_folder_name, $value))
      {
        unset ($network_folder_ini['default']['name'][$key]);
        unset ($network_folder_ini['default']['type'][$key]);
        unset ($network_folder_ini['default']['server'][$key]);
        unset ($network_folder_ini['default']['directory'][$key]);
        unset ($network_folder_ini['default']['user'][$key]);
        unset ($network_folder_ini['default']['password'][$key]);
        unset ($network_folder_ini['default']['protocol'][$key]);
        INI::write($this->_path_to_network_folder_config, $network_folder_ini);
        return true;
      }
    }

    return false;
  }

  public function get_info_from_network_folder ($network_folder_name)
  {
    if (!self::_opened == $this->_status)
      return false;

    $network_folder_ini = INI::read ($this->_path_to_network_folder_config);

    foreach ($network_folder_ini['default']['name'] as $key => $value)
    {
      if (!strcasecmp ($network_folder_name, $value))
      {
        $info[] = array
          (
            'name'      => $network_folder_ini['default']['name'][$key],
            'type'      => $network_folder_ini['default']['type'][$key],
            'server'    => $network_folder_ini['default']['server'][$key],
            'directory' => $network_folder_ini['default']['directory'][$key],
            'user'      => $network_folder_ini['default']['user'][$key],
            'password'  => $network_folder_ini['default']['password'][$key],
            'protocol'  => $network_folder_ini['default']['protocol'][$key]
          );

        return $info;
      }
    }

    return false;
  }

  public function edit_network_folder ($name, $type, $server, $directory, $user, $password, $protocol)
  {
    if (!self::_opened == $this->_status)
      return false;

    $network_folder_ini = INI::read ($this->_path_to_network_folder_config);

    foreach ($network_folder_ini['default']['name'] as $key => $value)
    {
      if (!strcasecmp ($name, $value))
      {
        $network_folder_ini['default']['name'][$key] = $name;
        $network_folder_ini['default']['type'][$key] = (int)(bool)$type;
        $network_folder_ini['default']['server'][$key] = $server;
        $network_folder_ini['default']['directory'][$key] = $directory;
        $network_folder_ini['default']['user'][$key] = $user;
        $network_folder_ini['default']['password'][$key] = $password;
        $network_folder_ini['default']['protocol'][$key] = (int)(bool)$protocol;

        INI::write($this->_path_to_network_folder_config, $network_folder_ini);
        return true;
      }
    }

    return false;
  }

  public function new_network_folder ($name, $type, $server, $directory, $user, $password, $protocol)
  {
    if (!self::_opened == $this->_status)
      return false;

    $network_folder_ini = INI::read ($this->_path_to_network_folder_config);

    foreach ($network_folder_ini['default']['name'] as $key => $value)
    {
      if (!strcasecmp ($name, $value))
      {
        return false;
      }
    }

    $network_folder_ini['default']['name'][$key] = $name;
    $network_folder_ini['default']['type'][$key] = ($type != 0)?'1':'0';
    $network_folder_ini['default']['server'][$key] = $server;
    $network_folder_ini['default']['directory'][$key] = $directory;
    $network_folder_ini['default']['user'][$key] = $user;
    $network_folder_ini['default']['password'][$key] = $password;
    $network_folder_ini['default']['protocol'][$key] = ($protocol != 0)?'1':'0';

    INI::write($this->_path_to_network_folder_config, $network_folder_ini);
    return true;
  }
}
