<?php

/**
 * @author: Andrii Kopyniak
 * @date: 2013 Jan 16
 *
 * @description:
 * Browse you files and folders on HDD, home network, USB starage, etc.
 */

require_once "config_parsers.php";

class sources
{
  private function get_network_folders (&$network_folders)
  {
    $path_to_network_folder_config = '/mnt/config/network_folders.properties';
    $network_folder_ini = INI::read ($path_to_network_folder_config);

    foreach ($network_folder_ini['default']['name'] as $network_folder_name)
    {
      $network_folders[] = array
        (
          'name' => $network_folder_name,
          'type' => 'network_folder' 
        );
    }

    return $network_folders;
  }

  private function get_network_browser (&$sources)
  {
    $sources[] = array ('name' => 'Network Browser', 'type' => 'network_browser');

    return $sources;
  }

  private function get_storeges (&$storage_dirs)
  {
    $storage_directory = '/tmp/mnt/storage';

    $files = scandir ($storage_directory);

    foreach ($files as $index => $file_name)
    {
      if (!strcasecmp ($file_name, '.') || !strcasecmp ($file_name, '..'))
      {
        continue;
      }

      /**
       * CDROM_DEVICE_NAME=/dev/sr0
       * CDROM_MOUNT_POINT=/cdrom
       */
      $storage_dirs[] = array
        (
          'name' => $file_name,
          'type' => 'usb_storage' 
        );
    }

    return $storage_dirs;
  }

  public function get_sources ()
  {
    $sources = array ();

    // Add "devices" 
    $this->get_network_browser ($sources);
    $this->get_network_folders ($sources);
    $this->get_storeges ($sources);

    return $sources;
  }
}
